include:
- local: multi-maven.yml


.java-codeformat-checkstyle:
  extends: .maven
  stage: test
  script:
  - mvn checkstyle:check

.java-codeformat-spotless:
  extends: .maven
  stage: test
  script:
  - '# shellcheck disable=SC2086'
  - MAVEN_OPTS="$MAVEN_OPTS --add-exports jdk.compiler/com.sun.tools.javac.api=ALL-UNNAMED --add-exports jdk.compiler/com.sun.tools.javac.file=ALL-UNNAMED --add-exports jdk.compiler/com.sun.tools.javac.parser=ALL-UNNAMED --add-exports jdk.compiler/com.sun.tools.javac.tree=ALL-UNNAMED --add-exports jdk.compiler/com.sun.tools.javac.util=ALL-UNNAMED"
  - mvn spotless:check

.java-codequality-pmd-javadoc:
  extends: .maven
  stage: test
  script:
    - '# shellcheck disable=SC2317'
    - !reference [.multi-maven, do-in-modules, init]
    - !reference [.multi-maven, do-in-modules, declare-function]
    - exit_code=0
    - mvn compile test-compile pmd:cpd pmd:pmd javadoc:javadoc javadoc:aggregate pmd:cpd-check pmd:check || exit_code=1
    - |
      function print_doc_links() {
        local artifact_name="$1"
        local module_path="$2"
        local relative_module_path
        relative_module_path="$(realpath --relative-to="$CI_PROJECT_DIR" "$module_path")"

        echo "JavaDoc URL for ${artifact_name}: ${CI_JOB_URL}/artifacts/file/${relative_module_path}/target/reports/apidocs/index.html"
        if ! grep -q 'PMD found no problems in your source code.' "${module_path}/target/reports/pmd.html"; then
          echo "PMD Report URL for ${artifact_name}: ${CI_JOB_URL}/artifacts/file/${relative_module_path}/target/reports/pmd.html"
        fi
        if ! grep -q 'CPD found no problems in your source code.' "${module_path}/target/reports/cpd.html"; then
          echo "CPD Report URL for ${artifact_name}: ${CI_JOB_URL}/artifacts/file/${relative_module_path}/target/reports/cpd.html"
        fi
      }
    - do_in_mvn_reactor "print_doc_links" "false"
    - exit "$exit_code"
  artifacts:
    paths:
    - "$MAVEN_WORK_DIR/target/reports"
    - "$MAVEN_WORK_DIR/*/target/reports"
    when: always

.java-codequality-errorprone:
  extends: .maven
  stage: test
  script:
  - mvn compile test-compile -P errorprone

.java-clean-dependency-graph:
  extends: .maven
  stage: test
  script:
  - mvn enforcer:enforce

.java-no-beta-version-dependencies:
  extends: .maven
  stage: test
  script:
  - !reference [.multi-maven, do-in-modules, init]
  - !reference [.multi-maven, do-in-modules, declare-function]
  - |
    function find_beta_versions() {
      local module_path="$2"
      local current_pom="${module_path}/pom.xml"

      # Selects a '<com.example.version>' tag along with it's contents
      local xpath_property="//*[substring(name(), string-length(name()) - 7) = '.version' and contains(text(), '-beta-')]"
      # Finds all '<version>' tags with beta versions
      local xpath_dependency="//*[name()='version' and contains(text(), '-beta-')]"

      local all_beta_versions
      local count

      all_beta_versions="$(xmlstarlet sel -I -t -v "$xpath_property" -v "$xpath_dependency" "$current_pom" || true)"
      count=$(echo "$all_beta_versions" | wc -w)
      if [[ $count -gt 0 ]]; then
        echo "Found beta version(s) in $current_pom:"

        all_beta_versions=$(xmlstarlet sel -I -t -v "$xpath_property" -n -v "$xpath_dependency" -n "$current_pom")
        readarray -t beta_versions <<<"$(echo -n "$all_beta_versions" | sed 's/  */ /g' | awk NF)"
        local i
        for ((i = 0; i < "${#beta_versions[@]}"; i++)); do
          grep -n -F -C 3 "${beta_versions[i]}" "$current_pom" --color=always
          echo ""
        done

        return 1
      else
        echo "No beta versions found in pom: $current_pom"
        return 0
      fi
    }
  - do_in_mvn_reactor "find_beta_versions" "true"
